## nodejs 12.20.1~dfsg

=== debian/changelog ===
nodejs (12.20.1~dfsg-3) unstable; urgency=medium

  * Team upload
  * Provide node-types-node (Closes: #979698)

 -- Xavier Guimard <yadd@debian.org>  Mon, 11 Jan 2021 13:05:02 +0100

nodejs (12.20.1~dfsg-2) unstable; urgency=medium

  * Team upload
  * Indicate that it breaks node-typescript-types < 20210110~
    (Closes: #979693)

 -- Xavier Guimard <yadd@debian.org>  Sun, 10 Jan 2021 10:18:57 +0100

nodejs (12.20.1~dfsg-1) unstable; urgency=medium

  * New upstream version 12.20.1~dfsg. Closes: #979364.
    Fixed vulnerabilities:
    + CVE-2020-8265: use-after-free in TLSWrap (High)
    + CVE-2020-8287: HTTP Request Smuggling (Low)
  * Patch to always use pure javascript cjs lexer instead
    of wasm files that can't be generated with currently
    available packages.
  * copyright: cjs-module-lexer is expat
  * copyright: exclude cjs-module-lexer unbuildable files
  * copyright: fix some copyright years
  * lintian-overrides: false positive for a unicode regexp
  * copyright: shjs is no longer used

 -- Jérémy Lal <kapouer@melix.org>  Sun, 10 Jan 2021 00:02:53 +0100

=== debian/control ===
Source: nodejs
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends:
 debhelper-compat (= 12),
 dh-buildinfo,
 bash-completion,
 ca-certificates,
 curl,
 gyp (>= 0.1~svn1773),
 jq,
 libbrotli-dev,
 libc-ares-dev (>= 1.14~),
 libhttp-parser-dev (>= 2.9.2~),
 libicu-dev (>= 64.0~),
 libkvm-dev [kfreebsd-any],
 libnghttp2-dev (>= 1.41.0~),
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.33.0~),
 node-acorn (>= 6.2.1~),
 openssl (>= 1.1.1~),
 pkg-config,
 pkg-js-tools (>= 0.8.2~),
 python3,
 python3-distutils,
 procps,
 zlib1g-dev,
Build-Depends-Indep: node-js-yaml,
 node-marked
Standards-Version: 4.5.0
Homepage: http://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-12.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-12.x

Package: libnode-dev
Section: libdevel
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Depends: ${misc:Depends},
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.33.0~),
 libnode72 (= ${binary:Version})
Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
Replaces: libv8-dev,
 nodejs-dev (<< 10.0.0~dfsg1-3)
Conflicts: libv8-dev (<= 3.14.5.8-11)
Provides: libv8-dev
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package provides development headers for libnode72

Package: nodejs
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libnode72 (= ${binary:Version})
Recommends: ca-certificates,
 nodejs-doc
Suggests: npm
Replaces: nodejs-legacy
Conflicts: nodejs-legacy
Breaks: node-typescript-types (<< 20210110~)
Provides: node-types-node (= ${types:Node})
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: libnode72
Section: libs
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends},
 sse2-support [i386]
Breaks: node-modern-syslog (<< 1.1.4-2),
 libnode64
Replaces: nodejs-legacy
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime library
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package provides the dynamic library for Node.js.

Package: nodejs-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: nodejs
Depends: ${misc:Depends}
 , libjs-highlight.js
Replaces: nodejs (<< 6.11.2~dfsg-3)
Conflicts: nodejs (<< 6.11.2~dfsg-3)
Description: API documentation for Node.js, the javascript platform
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains API documentation for Node.js.

=== debian/watch ===
version=3
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.xz/,\
dversionmangle=s/~dfsg\d*$//,\
repacksuffix=~dfsg \
https://nodejs.org/dist v(12\.\d+\.\d+)/

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,component=types-node,pgpmode=none" \
 https://registry.npmjs.org/@types/node https://registry.npmjs.org/@types/node/-/node-(12[\d\.]+)@ARCHIVE_EXT@ ignore

## nodejs 12.20.2~dfsg

=== debian/changelog ===
nodejs (12.20.2~dfsg-2) unstable; urgency=medium

  * Source-only upload. Closes: #982787 

 -- Jérémy Lal <kapouer@melix.org>  Sun, 14 Feb 2021 15:37:36 +0100

nodejs (12.20.2~dfsg-1) unstable; urgency=medium

  * New upstream version 12.20.2~dfsg

  [ lintian-brush ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Security-Contact.

  [ Xavier Guimard ]
  * Bump debhelper compatibility level to 13
  * Declare compliance with policy 4.5.1
  * Add "Rules-Requires-Root: no"
  * Modernize debian/watch
  * Add ctype=nodejs to component(s)
  * Update d/copyright urls

 -- Jérémy Lal <kapouer@melix.org>  Fri, 12 Feb 2021 10:35:48 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^\#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = \
--without-npm \
--shared \
--shared-zlib \
--shared-cares \
--shared-nghttp2 \
--shared-brotli \
--with-intl=system-icu \
--prefix=/usr \
--openssl-use-def-ca-store \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs" \
--shared-libuv

DEB_CONFIGURE_EXTRA_FLAGS += --shared-openssl

# map HOST ARCH AND OS, and if unknown let upstream guess

destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

# solaris freebsd openbsd linux
destOs =
destOs := $(or $(destOs),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
destOs := $(or $(destOs),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

ifeq (freebsd, $(destOs))
LDFLAGS += -lbsd
endif

# mips and fpu
# https://github.com/paul99/v8m-rb/issues/192
# https://bugs.debian.org/800410
# mips and big binaries
# http://gcc.gnu.org/wiki/DebugFission
# https://bugs.debian.org/829139

# use r2, which is the supported variant for these architectures
# https://lists.debian.org/debian-mips/2016/07/msg00000.html
ifeq (mipsel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian defaults
# v8 does not support < armv5
CXXFLAGS += -march=armv5t
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
DEB_MAKE_BUILD_TARGET = build

#  relax regression tests when targeted experimental suite
export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp
# needed for tests to avoid "ee key too small" errors
export OPENSSL_CONF = ./deps/openssl/openssl/apps/openssl.cnf
# keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js

# build -fPIC
CFLAGS += -fPIC
CPPFLAGS += -fPIC

ifeq ($(DEB_HOST_ARCH_BITS),32)
CFLAGS += -g1
CPPFLAGS += -g1
DH_FLAGS += --max-parallel=1
export JOBS = 1
else
CFLAGS += -g
CPPFLAGS += -g
endif


# hardening gyp
CXXFLAGS += $(CPPFLAGS)

export CPPFLAGS
export CXXFLAGS
export CFLAGS
export LDFLAGS

export PYTHON = python3

# disable DNS requests during tests
export RES_OPTIONS = attempts:0

%:
	dh $@ $(DH_FLAGS)

# properly clean files from build, test, python
override_dh_auto_clean:
	dh_auto_clean
	rm -f icu_config.gypi
	rm -rf test/addons/doc-*
	rm -f test/addons/.buildstamp
	rm -f test/addons/.docbuildstamp
	rm -rf test/addons/*/build
	rm -f config.gypi
	rm -f config.mk
	rm -f config.status
	rm -f test/fixtures/hello.txt
	rm -rf $(NODE_TEST_DIR)
	find . -name "*.pyc" -delete
	rm -rf out
	rm -rf deps/acorn/
	rm -f debian/libnode$(ABI).install
	rm -f debian/libnode-dev.links

# remove *.json files from documentation
override_dh_installdocs:
	dh_installdocs
	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete || true

override_dh_auto_configure:
	./configure $(DEB_CONFIGURE_EXTRA_FLAGS)

override_dh_auto_build-arch:
	mkdir -p $(NODE_TEST_DIR)
	mkdir -p deps/acorn/
	ln -sTf $(shell nodepath acorn) deps/acorn/acorn
	ln -sTf $(shell nodepath acorn-walk) deps/acorn/acorn-walk
	dh_auto_build

override_dh_auto_build-indep:
	NODE_PATH=/usr/share/nodejs:/usr/lib/nodejs $(MAKE) doc-only

override_dh_auto_test-indep:
	# skip tests

override_dh_auto_test-arch:
	$(MAKE) test-ci-js

override_dh_auto_install-indep:
	# skip install all

override_dh_auto_install-arch:
	dh_auto_install

override_dh_install-arch:
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' debian/libnode.install > debian/libnode$(ABI).install
	sed -e 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' -e 's/@ABI@/$(ABI)/g' debian/libnode-dev.links.in > debian/libnode-dev.links
	dh_install

override_dh_dwz:
	# Double up the limit of debug information entries
	# Also, ignore failures (on 32-bit archs it might fail)
	-dh_dwz -- --max-die-limit 100000000

override_dh_gencontrol:
	dh_gencontrol -- \
	 -V"types:Node=$(shell jq --raw-output .version <types-node/package.json)~$(DEB_VERSION)"

check:
	-ln -s /usr/bin/node node
	mkdir -p $(NODE_TEST_DIR)
	$(MAKE) $(DEB_MAKE_CHECK_TARGET)
	rm -f node
	rm -rf $(NODE_TEST_DIR)

## nodejs 12.21.0~dfsg

=== debian/changelog ===
nodejs (12.21.0~dfsg-3) unstable; urgency=medium

  * Upstream patch fix test-worker-prof (Closes: #985550)

 -- Jérémy Lal <kapouer@melix.org>  Fri, 19 Mar 2021 18:43:52 +0100

nodejs (12.21.0~dfsg-2) unstable; urgency=medium

  [ James Addison ]
  * THP ELF assembly: Add .note.GNU-stack section (Closes: #980272)

 -- Jérémy Lal <kapouer@melix.org>  Fri, 19 Mar 2021 11:15:57 +0100

nodejs (12.21.0~dfsg-1) unstable; urgency=high

  * New upstream version 12.21.0~dfsg
    Fixed vulnerabilities:
    + CVE-2021-22883: HTTP2 'unknownProtocol' cause DoS
      by resource exhaustion
    + CVE-2021-22884: localhost6 DNS rebinding in --inspect

 -- Jérémy Lal <kapouer@melix.org>  Tue, 23 Feb 2021 19:14:23 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Jérémy Lal <kapouer@melix.org>,
  Jonas Smedegaard <dr@jones.dk>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-buildinfo,
  bash-completion,
  ca-certificates,
@@ -30,10 +30,11 @@
  zlib1g-dev,
 Build-Depends-Indep: node-js-yaml,
  node-marked
-Standards-Version: 4.5.0
-Homepage: http://nodejs.org/
+Standards-Version: 4.5.1
+Homepage: https://nodejs.org/
 Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-12.x
 Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-12.x
+Rules-Requires-Root: no
 
 Package: libnode-dev
 Section: libdevel
@@ -132,4 +133,3 @@
  HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
  .
  This package contains API documentation for Node.js.
-

## nodejs 12.22.5~dfsg

=== debian/changelog ===
nodejs (12.22.5~dfsg-5ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing
    - Cherry-pick upstream 7232c2a1604d241ce0455d919ba9b0b8e9959f81
      to fix a build failure with new glibc

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Sep 2021 11:36:21 +0200

nodejs (12.22.5~dfsg-5) unstable; urgency=medium

  * Team upload
  * b-d sse2-support <!nocheck> [i386] in order
    to improve cross build

 -- Bastien Roucariès <rouca@debian.org>  Tue, 21 Sep 2021 08:16:57 +0000

nodejs (12.22.5~dfsg-4) unstable; urgency=medium

  * Team upload
  * b-d sse2-support (Closes: #994720)

 -- Bastien Roucariès <rouca@debian.org>  Sun, 19 Sep 2021 20:34:51 +0000

nodejs (12.22.5~dfsg-3) unstable; urgency=medium

  * Team upload
  * MA: allowed. Thanks Helmut for helping fix crossbuild.

 -- Bastien Roucariès <rouca@debian.org>  Thu, 16 Sep 2021 20:20:43 +0000

nodejs (12.22.5~dfsg-2ubuntu2) impish; urgency=medium

  * Cherry-pick upstream 7232c2a1604d241ce0455d919ba9b0b8e9959f81
    to fix a build failure with new glibc

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Aug 2021 09:51:31 +0200

nodejs (12.22.5~dfsg-2ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Aug 2021 22:18:45 +0200

nodejs (12.22.5~dfsg-2) unstable; urgency=medium

  * ares_compat.patch let node compile against ares < 1.17.2
    Closes: #992112

 -- Jérémy Lal <kapouer@melix.org>  Wed, 11 Aug 2021 21:06:00 +0200

nodejs (12.22.5~dfsg-1) unstable; urgency=medium

  * New upstream version 12.22.5~dfsg
    + Follow-up fix for CVE-2021-22930 as the issue was not completely
      resolved by the version 12.22.4 (High).
    + CVE-2021-22939: Incomplete validation of rejectUnauthorized
      parameter (Low).

 -- Jérémy Lal <kapouer@melix.org>  Wed, 11 Aug 2021 19:36:57 +0200

nodejs (12.22.4~dfsg-1ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 02 Aug 2021 21:35:41 +0200

nodejs (12.22.4~dfsg-1) unstable; urgency=medium

  * New upstream version 12.22.4~dfsg
    Fixed vulnerabilities:
    + CVE-2021-22930: Use after free on close http2
      on stream canceling (High)

 -- Jérémy Lal <kapouer@melix.org>  Fri, 30 Jul 2021 01:02:46 +0200

nodejs (12.21.0~dfsg-5ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 05 Jul 2021 16:05:45 +0200

nodejs (12.21.0~dfsg-5) unstable; urgency=medium

  * Patch uvwasi.gyp to honour --shared-libuv. Closes: #990569.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 03 Jul 2021 20:50:29 +0200

nodejs (12.21.0~dfsg-4ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 28 Apr 2021 17:41:21 +0200

nodejs (12.21.0~dfsg-4) unstable; urgency=medium

  [ Andreas Beckmann ]
  * nodejs: Add Breaks: node-babel-runtime (<< 7)
    for smoother upgrades from buster. (Closes: #987301)

 -- Jérémy Lal <kapouer@melix.org>  Wed, 21 Apr 2021 12:42:46 +0200

nodejs (12.21.0~dfsg-3ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 20 Mar 2021 10:05:40 +0100

nodejs (12.21.0~dfsg-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 25 Feb 2021 21:22:47 +0100

nodejs (12.20.1~dfsg-3ubuntu1) hirsute; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 11 Jan 2021 15:21:40 +0100

nodejs (12.20.1~dfsg-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 10 Jan 2021 17:52:34 +0100

nodejs (12.19.0~dfsg-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 29 Oct 2020 15:14:11 +0100

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Uploaders: Jérémy Lal <kapouer@melix.org>,
  Jonas Smedegaard <dr@jones.dk>
 Build-Depends:
+ sse2-support [i386] <!nocheck>,
  debhelper-compat (= 13),
  dh-buildinfo,
  bash-completion,
@@ -59,17 +60,18 @@
 
 Package: nodejs
 Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
-Multi-Arch: foreign
+Multi-Arch: allowed
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- libnode72 (= ${binary:Version})
+ libnode72 (= ${binary:Version}),
+ sse2-support [i386]
 Recommends: ca-certificates,
  nodejs-doc
 Suggests: npm
 Replaces: nodejs-legacy
 Conflicts: nodejs-legacy
-Breaks: node-typescript-types (<< 20210110~)
+Breaks: node-typescript-types (<< 20210110~), node-babel-runtime (<< 7)
 Provides: node-types-node (= ${types:Node})
 Description: evented I/O for V8 javascript - runtime executable
  Node.js is a platform built on Chrome's JavaScript runtime for easily

## nodejs 12.22.9~dfsg

=== deps/uv/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(libuv LANGUAGES C)

cmake_policy(SET CMP0057 NEW) # Enable IN_LIST operator
cmake_policy(SET CMP0064 NEW) # Support if (TEST) operator

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(CMakePackageConfigHelpers)
include(CMakeDependentOption)
include(CheckCCompilerFlag)
include(GNUInstallDirs)
include(CTest)

set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS ON)
set(CMAKE_C_STANDARD 90)

cmake_dependent_option(LIBUV_BUILD_TESTS
  "Build the unit tests when BUILD_TESTING is enabled and we are the root project" ON
  "BUILD_TESTING;CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR" OFF)
cmake_dependent_option(LIBUV_BUILD_BENCH
  "Build the benchmarks when building unit tests and we are the root project" ON
  "LIBUV_BUILD_TESTS" OFF)

# Qemu Build
option(QEMU "build for qemu" OFF)
if(QEMU)
  add_definitions(-D__QEMU__=1)
endif()

# Compiler check
string(CONCAT is-msvc $<OR:
  $<C_COMPILER_ID:MSVC>,
  $<STREQUAL:${CMAKE_C_COMPILER_FRONTEND_VARIANT},MSVC>
>)

check_c_compiler_flag(/W4 UV_LINT_W4)
check_c_compiler_flag(/wd4100 UV_LINT_NO_UNUSED_PARAMETER_MSVC)
check_c_compiler_flag(/wd4127 UV_LINT_NO_CONDITIONAL_CONSTANT_MSVC)
check_c_compiler_flag(/wd4201 UV_LINT_NO_NONSTANDARD_MSVC)
check_c_compiler_flag(/wd4206 UV_LINT_NO_NONSTANDARD_EMPTY_TU_MSVC)
check_c_compiler_flag(/wd4210 UV_LINT_NO_NONSTANDARD_FILE_SCOPE_MSVC)
check_c_compiler_flag(/wd4232 UV_LINT_NO_NONSTANDARD_NONSTATIC_DLIMPORT_MSVC)
check_c_compiler_flag(/wd4456 UV_LINT_NO_HIDES_LOCAL)
check_c_compiler_flag(/wd4457 UV_LINT_NO_HIDES_PARAM)
check_c_compiler_flag(/wd4459 UV_LINT_NO_HIDES_GLOBAL)
check_c_compiler_flag(/wd4706 UV_LINT_NO_CONDITIONAL_ASSIGNMENT_MSVC)
check_c_compiler_flag(/wd4996 UV_LINT_NO_UNSAFE_MSVC)

check_c_compiler_flag(-Wall UV_LINT_WALL) # DO NOT use this under MSVC

# TODO: Place these into its own function
check_c_compiler_flag(-Wno-unused-parameter UV_LINT_NO_UNUSED_PARAMETER)
check_c_compiler_flag(-Wstrict-prototypes UV_LINT_STRICT_PROTOTYPES)
check_c_compiler_flag(-Wextra UV_LINT_EXTRA)

check_c_compiler_flag(/utf-8 UV_LINT_UTF8_MSVC)

set(lint-no-unused-parameter $<$<BOOL:${UV_LINT_NO_UNUSED_PARAMETER}>:-Wno-unused-parameter>)
set(lint-strict-prototypes $<$<BOOL:${UV_LINT_STRICT_PROTOTYPES}>:-Wstrict-prototypes>)
set(lint-extra $<$<BOOL:${UV_LINT_EXTRA}>:-Wextra>)
set(lint-w4 $<$<BOOL:${UV_LINT_W4}>:/W4>)
set(lint-no-unused-parameter-msvc $<$<BOOL:${UV_LINT_NO_UNUSED_PARAMETER_MSVC}>:/wd4100>)
set(lint-no-conditional-constant-msvc $<$<BOOL:${UV_LINT_NO_CONDITIONAL_CONSTANT_MSVC}>:/wd4127>)
set(lint-no-nonstandard-msvc $<$<BOOL:${UV_LINT_NO_NONSTANDARD_MSVC}>:/wd4201>)
set(lint-no-nonstandard-empty-tu-msvc $<$<BOOL:${UV_LINT_NO_NONSTANDARD_EMPTY_TU_MSVC}>:/wd4206>)
set(lint-no-nonstandard-file-scope-msvc $<$<BOOL:${UV_LINT_NO_NONSTANDARD_FILE_SCOPE_MSVC}>:/wd4210>)
set(lint-no-nonstandard-nonstatic-dlimport-msvc $<$<BOOL:${UV_LINT_NO_NONSTANDARD_NONSTATIC_DLIMPORT_MSVC}>:/wd4232>)
set(lint-no-hides-local-msvc $<$<BOOL:${UV_LINT_NO_HIDES_LOCAL}>:/wd4456>)
set(lint-no-hides-param-msvc $<$<BOOL:${UV_LINT_NO_HIDES_PARAM}>:/wd4457>)
set(lint-no-hides-global-msvc $<$<BOOL:${UV_LINT_NO_HIDES_GLOBAL}>:/wd4459>)
set(lint-no-conditional-assignment-msvc $<$<BOOL:${UV_LINT_NO_CONDITIONAL_ASSIGNMENT_MSVC}>:/wd4706>)
set(lint-no-unsafe-msvc $<$<BOOL:${UV_LINT_NO_UNSAFE_MSVC}>:/wd4996>)
# Unfortunately, this one is complicated because MSVC and clang-cl support -Wall
# but using it is like calling -Weverything
string(CONCAT lint-default $<
  $<AND:$<BOOL:${UV_LINT_WALL}>,$<NOT:${is-msvc}>>:-Wall
>)
set(lint-utf8-msvc $<$<BOOL:${UV_LINT_UTF8_MSVC}>:/utf-8>)

list(APPEND uv_cflags ${lint-strict-prototypes} ${lint-extra} ${lint-default} ${lint-w4})
list(APPEND uv_cflags ${lint-no-unused-parameter})
list(APPEND uv_cflags ${lint-no-unused-parameter-msvc})
list(APPEND uv_cflags ${lint-no-conditional-constant-msvc})
list(APPEND uv_cflags ${lint-no-nonstandard-msvc})
list(APPEND uv_cflags ${lint-no-nonstandard-empty-tu-msvc})
list(APPEND uv_cflags ${lint-no-nonstandard-file-scope-msvc})
list(APPEND uv_cflags ${lint-no-nonstandard-nonstatic-dlimport-msvc})
list(APPEND uv_cflags ${lint-no-hides-local-msvc})
list(APPEND uv_cflags ${lint-no-hides-param-msvc})
list(APPEND uv_cflags ${lint-no-hides-global-msvc})
list(APPEND uv_cflags ${lint-no-conditional-assignment-msvc})
list(APPEND uv_cflags ${lint-no-unsafe-msvc})
list(APPEND uv_cflags ${lint-utf8-msvc} )

set(uv_sources
    src/fs-poll.c
    src/idna.c
    src/inet.c
    src/random.c
    src/strscpy.c
    src/threadpool.c
    src/timer.c
    src/uv-common.c
    src/uv-data-getter-setters.c
    src/version.c)

if(WIN32)
  list(APPEND uv_defines WIN32_LEAN_AND_MEAN _WIN32_WINNT=0x0600)
  list(APPEND uv_libraries
       psapi
       user32
       advapi32
       iphlpapi
       userenv
       ws2_32)
  list(APPEND uv_sources
       src/win/async.c
       src/win/core.c
       src/win/detect-wakeup.c
       src/win/dl.c
       src/win/error.c
       src/win/fs.c
       src/win/fs-event.c
       src/win/getaddrinfo.c
       src/win/getnameinfo.c
       src/win/handle.c
       src/win/loop-watcher.c
       src/win/pipe.c
       src/win/thread.c
       src/win/poll.c
       src/win/process.c
       src/win/process-stdio.c
       src/win/signal.c
       src/win/snprintf.c
       src/win/stream.c
       src/win/tcp.c
       src/win/tty.c
       src/win/udp.c
       src/win/util.c
       src/win/winapi.c
       src/win/winsock.c)
  list(APPEND uv_test_libraries ws2_32)
  list(APPEND uv_test_sources src/win/snprintf.c test/runner-win.c)
else()
  list(APPEND uv_defines _FILE_OFFSET_BITS=64 _LARGEFILE_SOURCE)
  if(NOT CMAKE_SYSTEM_NAME MATCHES "Android|OS390|QNX")
    # TODO: This should be replaced with find_package(Threads) if possible
    # Android has pthread as part of its c library, not as a separate
    # libpthread.so.
    list(APPEND uv_libraries pthread)
  endif()
  list(APPEND uv_sources
       src/unix/async.c
       src/unix/core.c
       src/unix/dl.c
       src/unix/fs.c
       src/unix/getaddrinfo.c
       src/unix/getnameinfo.c
       src/unix/loop-watcher.c
       src/unix/loop.c
       src/unix/pipe.c
       src/unix/poll.c
       src/unix/process.c
       src/unix/random-devurandom.c
       src/unix/signal.c
       src/unix/stream.c
       src/unix/tcp.c
       src/unix/thread.c
       src/unix/tty.c
       src/unix/udp.c)
  list(APPEND uv_test_sources test/runner-unix.c)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "AIX")
  list(APPEND uv_defines
       _ALL_SOURCE
       _LINUX_SOURCE_COMPAT
       _THREAD_SAFE
       _XOPEN_SOURCE=500
       HAVE_SYS_AHAFS_EVPRODS_H)
  list(APPEND uv_libraries perfstat)
  list(APPEND uv_sources
       src/unix/aix.c
       src/unix/aix-common.c)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Android")
  list(APPEND uv_defines _GNU_SOURCE)
  list(APPEND uv_libraries dl)
  list(APPEND uv_sources
       src/unix/android-ifaddrs.c
       src/unix/linux-core.c
       src/unix/linux-inotify.c
       src/unix/linux-syscalls.c
       src/unix/procfs-exepath.c
       src/unix/pthread-fixes.c
       src/unix/random-getentropy.c
       src/unix/random-getrandom.c
       src/unix/random-sysctl-linux.c)
endif()

if(APPLE OR CMAKE_SYSTEM_NAME MATCHES "Android|Linux|OS390")
  list(APPEND uv_sources src/unix/proctitle.c)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "DragonFly|FreeBSD")
  list(APPEND uv_sources src/unix/freebsd.c)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "DragonFly|FreeBSD|NetBSD|OpenBSD")
  list(APPEND uv_sources src/unix/posix-hrtime.c src/unix/bsd-proctitle.c)
endif()

if(APPLE OR CMAKE_SYSTEM_NAME MATCHES "DragonFly|FreeBSD|NetBSD|OpenBSD")
  list(APPEND uv_sources src/unix/bsd-ifaddrs.c src/unix/kqueue.c)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  list(APPEND uv_sources src/unix/random-getrandom.c)
endif()

if(APPLE OR CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
  list(APPEND uv_sources src/unix/random-getentropy.c)
endif()

if(APPLE)
  list(APPEND uv_defines _DARWIN_UNLIMITED_SELECT=1 _DARWIN_USE_64_BIT_INODE=1)
  list(APPEND uv_sources
       src/unix/darwin-proctitle.c
       src/unix/darwin.c
       src/unix/fsevents.c)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  list(APPEND uv_defines _GNU_SOURCE _POSIX_C_SOURCE=200112)
  list(APPEND uv_libraries dl rt)
  list(APPEND uv_sources
       src/unix/linux-core.c
       src/unix/linux-inotify.c
       src/unix/linux-syscalls.c
       src/unix/procfs-exepath.c
       src/unix/random-getrandom.c
       src/unix/random-sysctl-linux.c)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
  list(APPEND uv_sources src/unix/netbsd.c)
  list(APPEND uv_libraries kvm)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
  list(APPEND uv_sources src/unix/openbsd.c)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "OS390")
  list(APPEND uv_defines PATH_MAX=255)
  list(APPEND uv_defines _AE_BIMODAL)
  list(APPEND uv_defines _ALL_SOURCE)
  list(APPEND uv_defines _ISOC99_SOURCE)
  list(APPEND uv_defines _LARGE_TIME_API)
  list(APPEND uv_defines _OPEN_MSGQ_EXT)
  list(APPEND uv_defines _OPEN_SYS_FILE_EXT)
  list(APPEND uv_defines _OPEN_SYS_IF_EXT)
  list(APPEND uv_defines _OPEN_SYS_SOCK_EXT3)
  list(APPEND uv_defines _OPEN_SYS_SOCK_IPV6)
  list(APPEND uv_defines _UNIX03_SOURCE)
  list(APPEND uv_defines _UNIX03_THREADS)
  list(APPEND uv_defines _UNIX03_WITHDRAWN)
  list(APPEND uv_defines _XOPEN_SOURCE_EXTENDED)
  list(APPEND uv_sources
       src/unix/pthread-fixes.c
       src/unix/os390.c
       src/unix/os390-syscalls.c)
  list(APPEND uv_cflags -Wc,DLL -Wc,exportall -Wc,xplink)
  list(APPEND uv_libraries -Wl,xplink)
  list(APPEND uv_test_libraries -Wl,xplink)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "OS400")
  list(APPEND uv_defines
       _ALL_SOURCE
       _LINUX_SOURCE_COMPAT
       _THREAD_SAFE
       _XOPEN_SOURCE=500)
  list(APPEND uv_sources
    src/unix/aix-common.c
    src/unix/ibmi.c
    src/unix/no-fsevents.c
    src/unix/posix-poll.c)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  list(APPEND uv_defines __EXTENSIONS__ _XOPEN_SOURCE=500)
  list(APPEND uv_libraries kstat nsl sendfile socket)
  list(APPEND uv_sources src/unix/no-proctitle.c src/unix/sunos.c)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Haiku")
  list(APPEND uv_defines _BSD_SOURCE)
  list(APPEND uv_libraries bsd network)
  list(APPEND uv_sources
	  src/unix/haiku.c
	  src/unix/bsd-ifaddrs.c
	  src/unix/no-fsevents.c
	  src/unix/no-proctitle.c
	  src/unix/posix-hrtime.c
	  src/unix/posix-poll.c)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "QNX")
  list(APPEND uv_sources
    src/unix/posix-hrtime.c
    src/unix/posix-poll.c
    src/unix/qnx.c
    src/unix/bsd-ifaddrs.c
    src/unix/no-proctitle.c
    src/unix/no-fsevents.c)
  list(APPEND uv_cflags -fno-strict-aliasing)
  list(APPEND uv_libraries socket)
endif()

if(APPLE OR CMAKE_SYSTEM_NAME MATCHES "DragonFly|FreeBSD|Linux|NetBSD|OpenBSD")
  list(APPEND uv_test_libraries util)
endif()

add_library(uv SHARED ${uv_sources})
target_compile_definitions(uv
  INTERFACE
    USING_UV_SHARED=1
  PRIVATE
    BUILDING_UV_SHARED=1
    ${uv_defines})
target_compile_options(uv PRIVATE ${uv_cflags})
target_include_directories(uv
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>)
target_link_libraries(uv ${uv_libraries})

add_library(uv_a STATIC ${uv_sources})
target_compile_definitions(uv_a PRIVATE ${uv_defines})
target_compile_options(uv_a PRIVATE ${uv_cflags})
target_include_directories(uv_a
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>)
target_link_libraries(uv_a ${uv_libraries})

if(LIBUV_BUILD_TESTS)
  # Small hack: use ${uv_test_sources} now to get the runner skeleton,
  # before the actual tests are added.
  add_executable(
    uv_run_benchmarks_a

=== test/wasi/Makefile ===
CC = /opt/wasi-sdk/bin/clang
TARGET = wasm32-unknown-wasi
SYSROOT =

OBJ = $(patsubst c/%.c, wasm/%.wasm, $(wildcard c/*.c))
all: $(OBJ)

wasm/%.wasm : c/%.c
	$(CC) $< --target=$(TARGET) --sysroot=$(SYSROOT) -s -o $@

.PHONY clean:
	rm -f $(OBJ)

=== debian/changelog ===
nodejs (12.22.9~dfsg-1ubuntu3.6) jammy-security; urgency=medium

  * SECURITY UPDATE: Bypass the Policy Mechanism
    - debian/patches/CVE-2023-32002.patch: fixed a policy mechanism bypass in
      `Module._load` (CVE-2023-32002) and one in `constructor.createRequire`
      (CVE-2023-32006)
    - debian/patches/CVE-2023-32559.patch: fixed a privilege escalation in
      process.binding
    - CVE-2023-32002
    - CVE-2023-32006
    - CVE-2023-32559

 -- Amir Naseredini <amir.naseredini@canonical.com>  Fri, 07 Jun 2024 16:17:56 +0100

nodejs (12.22.9~dfsg-1ubuntu3.5) jammy-security; urgency=medium

  * SECURITY UPDATE: Incorrect Documentation for Diffie-Hellman APIs
    - debian/patches/CVE-2023-30590.patch: fixed the inconsistency between the
      documents and the function of Diffie-Hellman APIs
    - CVE-2023-30590

 -- Amir Naseredini <amir.naseredini@canonical.com>  Wed, 03 Apr 2024 09:09:24 +0100

nodejs (12.22.9~dfsg-1ubuntu3.4) jammy-security; urgency=medium

  * SECURITY UPDATE: Privilege Escalation
    - debian/patches/CVE-2023-23920.patch: added `ICU_NO_USER_DATA_OVERRIDE` to
      fix an issue with insecure loading of ICU data
    - CVE-2023-23920
  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2023-2650.patch: fixed an issue in openssl in nodejs
    - CVE-2023-2650

 -- Amir Naseredini <amir.naseredini@canonical.com>  Wed, 21 Feb 2024 18:32:20 +0000

nodejs (12.22.9~dfsg-1ubuntu3.3) jammy-security; urgency=medium

  * SECURITY UPDATE: Obtain Sensitive Information
    - debian/patches/CVE-2022-4304.patch: fixed a timing based side channel in
      the OpenSSL RSA Decryption implementation
    - debian/patches/CVE-2023-0286.patch: fixed a type confusion vulnerability
      in GENERAL_NAME_cmp function
    - CVE-2022-4304
    - CVE-2023-0286
  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2022-4450.patch: fixed an issue that will result in a
      crash in PEM_read_bio_ex function
    - debian/patches/CVE-2023-0215.patch: fixed a use-after-free issue in
      BIO_new_NDEF function
    - debian/patches/CVE-2023-0401.patch: fixed a NULL pointer dereference in
      PKCS7
    - CVE-2022-4450
    - CVE-2023-0215
    - CVE-2023-0401

 -- Amir Naseredini <amir.naseredini@canonical.com>  Tue, 12 Dec 2023 18:34:04 +0000

nodejs (12.22.9~dfsg-1ubuntu3.2) jammy-security; urgency=medium

  * SECURITY UPDATE: Arbitrary Code Execution
    - debian/patches/CVE-2022-32212-1.patch: fixed IPv4 validation in
      inspector_socket
    - debian/patches/CVE-2022-32212-2.patch: fixed IPv4 non routable validation
    - debian/patches/CVE-2022-32213-1.patch: add common.mustSucceed for the -2
      patch
    - debian/patches/CVE-2022-32213-2.patch: stricter Transfer-Encoding and
      header separator parsing. Also fixes CVE-2022-32214 and CVE-2022-32215
    - debian/patches/CVE-2022-32213-3.patch: disabled chunked encoding when OBS
      fold is used. Also fixes CVE-2022-35256.
    - debian/patches/CVE-2022-43548.patch: harden IP address validation again
    - CVE-2022-32212
    - CVE-2022-32213
    - CVE-2022-32214
    - CVE-2022-32215
    - CVE-2022-35256
    - CVE-2022-43548

 -- Amir Naseredini <amir.naseredini@canonical.com>  Wed, 15 Nov 2023 15:29:18 +0000

nodejs (12.22.9~dfsg-1ubuntu3.1) jammy-security; urgency=medium

  * SECURITY UPDATE: Remote Code Execution
    - debian/patches/CVE-2022-1292.patch: fixed a remote code execution in
      openssl in nodejs
    - debian/patches/CVE-2022-2068.patch: fixed an arbitrary code execution in
      openssl in nodejs
    - debian/patches/CVE-2022-2097.patch: fixed a memory corruption in openssl
      in nodejs
    - CVE-2022-1292
    - CVE-2022-2068
    - CVE-2022-2097
  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2022-0778.patch: fixed an infinite loop in 
      BN_mod_sqrt module
    - CVE-2022-0778

 -- Amir Naseredini <amir.naseredini@canonical.com>  Thu, 26 Oct 2023 18:23:45 +0100

nodejs (12.22.9~dfsg-1ubuntu3) jammy; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Feb 2022 05:41:38 +0100

nodejs (12.22.9~dfsg-1ubuntu2) jammy; urgency=medium

  * Cherry-pick Python 3.10 upstream fixes:
    - debian/patches/24c403cfaf8bdbcd8b19037531c8998709d2b949.patch:
    - debian/patches/e548e053a2fda35f38272fb023f543e52ae77566.patch:

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 31 Jan 2022 23:17:20 +0100

nodejs (12.22.9~dfsg-1ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ubuntu is switching to openssl v3, however nodejs v12 must remain on
      openssl v1.1.1 abi. Thus switch from using shared system openssl to
      the vendored one.
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing
    - Cherry-pick upstream 7232c2a1604d241ce0455d919ba9b0b8e9959f81
      to fix a build failure with new glibc

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 31 Jan 2022 22:57:08 +0100

nodejs (12.22.9~dfsg-1) unstable; urgency=medium

  [ Yadd ]
  * Team upload
  * Add fix for node-js-yaml ≥ 4
  * Clean unneeded versioned dependency contraints

  [ Jérémy Lal ]
  * New upstream version 12.22.9~dfsg
  * Fix make-doc patch for marked 4
  * Depends on libuv >= 1.38.0
  * Apply js-yaml compatibility before make-doc patch

 -- Jérémy Lal <kapouer@melix.org>  Thu, 27 Jan 2022 13:42:36 +0100

nodejs (12.22.7~dfsg-2ubuntu3) jammy; urgency=medium

  * d/p/make-docs.patch: updated to take into account the API break in js-yaml

 -- Simon Chopin <simon.chopin@canonical.com>  Fri, 03 Dec 2021 18:16:44 +0100

nodejs (12.22.7~dfsg-2ubuntu2) jammy; urgency=medium

  * Ubuntu is switching to openssl v3, however nodejs v12 must remain on
    openssl v1.1.1 abi. Thus switch from using shared system openssl to
    the vendored one.

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Thu, 02 Dec 2021 19:33:41 +0000



=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: nodejs
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
+Uploaders: Jérémy Lal <kapouer@melix.org>,
+ Jonas Smedegaard <dr@jones.dk>
 Section: javascript
 Priority: optional
-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
-Uploaders: Jérémy Lal <kapouer@melix.org>,
- Jonas Smedegaard <dr@jones.dk>
 Build-Depends:
  sse2-support [i386] <!nocheck>,
  debhelper-compat (= 13),
@@ -11,44 +12,49 @@
  bash-completion,
  ca-certificates,
  curl,
- gyp (>= 0.1~svn1773),
+ gyp,
  jq,
  libbrotli-dev,
- libc-ares-dev (>= 1.14~),
+ libbrotli-dev:native,
+ libc-ares-dev,
+ libc-ares-dev:native,
  libhttp-parser-dev (>= 2.9.2~),
  libicu-dev (>= 64.0~),
+ libicu-dev:native,
  libkvm-dev [kfreebsd-any],
  libnghttp2-dev (>= 1.41.0~),
- libssl-dev (>= 1.1.1~),
- libuv1-dev (>= 1.33.0~),
+ libnghttp2-dev:native,
+ libssl-dev,
+ libssl-dev:native,
+ libuv1-dev (>= 1.38.0~),
+ libuv1-dev:native,
  node-acorn (>= 6.2.1~),
- openssl (>= 1.1.1~),
+ openssl,
  pkg-config,
  pkg-js-tools (>= 0.8.2~),
- python3,
+ python3:native,
  python3-distutils,
  procps,
  zlib1g-dev,
+ zlib1g-dev:native
 Build-Depends-Indep: node-js-yaml,
  node-marked
-Standards-Version: 4.5.1
-Homepage: https://nodejs.org/
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-12.x
 Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-12.x
+Homepage: https://nodejs.org/
 Rules-Requires-Root: no
 
 Package: libnode-dev
+Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
 Section: libdevel
-Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
 Depends: ${misc:Depends},
- libssl-dev (>= 1.1.1~),
+ libssl-dev,
  libuv1-dev (>= 1.33.0~),
  libnode72 (= ${binary:Version})
 Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
-Replaces: libv8-dev,
- nodejs-dev (<< 10.0.0~dfsg1-3)
-Conflicts: libv8-dev (<= 3.14.5.8-11)
 Provides: libv8-dev
+Replaces: nodejs-dev (<< 10.0.0~dfsg1-3)
 Description: evented I/O for V8 javascript (development files)
  Node.js is a platform built on Chrome's JavaScript runtime for easily
  building fast, scalable network applications. Node.js uses an
@@ -69,8 +75,6 @@
 Recommends: ca-certificates,
  nodejs-doc
 Suggests: npm
-Replaces: nodejs-legacy
-Conflicts: nodejs-legacy
 Breaks: node-typescript-types (<< 20210110~), node-babel-runtime (<< 7)
 Provides: node-types-node (= ${types:Node})
 Description: evented I/O for V8 javascript - runtime executable
@@ -87,16 +91,13 @@
  HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 
 Package: libnode72
-Section: libs
 Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
 Multi-Arch: same
+Section: libs
 Depends: ${shlibs:Depends},
  ${misc:Depends},
  sse2-support [i386]
-Breaks: node-modern-syslog (<< 1.1.4-2),
- libnode64
-Replaces: nodejs-legacy
-Conflicts: nodejs-legacy
+Breaks: libnode64
 Description: evented I/O for V8 javascript - runtime library
  Node.js is a platform built on Chrome's JavaScript runtime for easily
  building fast, scalable network applications. Node.js uses an
@@ -113,14 +114,12 @@
  This package provides the dynamic library for Node.js.
 
 Package: nodejs-doc
-Section: doc
 Architecture: all
 Multi-Arch: foreign
+Section: doc
+Depends: ${misc:Depends},
+ libjs-highlight.js
 Recommends: nodejs
-Depends: ${misc:Depends}
- , libjs-highlight.js
-Replaces: nodejs (<< 6.11.2~dfsg-3)
-Conflicts: nodejs (<< 6.11.2~dfsg-3)
 Description: API documentation for Node.js, the javascript platform
  Node.js is a platform built on Chrome's JavaScript runtime for easily
  building fast, scalable network applications. Node.js uses an

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
+include /usr/share/dpkg/buildtools.mk
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
 
 # source equivalent of nodejs -e 'console.log(process.versions.modules)'
@@ -16,20 +18,20 @@
 export LANG
 DEB_CONFIGURE_NORMAL_ARGS =
 DEB_CONFIGURE_EXTRA_FLAGS = \
+--verbose \
 --without-npm \
 --shared \
 --shared-zlib \
 --shared-cares \
---shared-nghttp2 \
 --shared-brotli \
 --with-intl=system-icu \
 --prefix=/usr \
 --openssl-use-def-ca-store \
 --arch-triplet=$(DEB_HOST_MULTIARCH) \
---node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs" \
---shared-libuv
-
-DEB_CONFIGURE_EXTRA_FLAGS += --shared-openssl
+--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs"
+
+DEB_CONFIGURE_EXTRA_FLAGS += --shared-nghttp2
+DEB_CONFIGURE_EXTRA_FLAGS += --shared-libuv
 
 # map HOST ARCH AND OS, and if unknown let upstream guess
 
@@ -198,7 +200,16 @@
 	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete || true
 
 override_dh_auto_configure:
+# gyp    | debian
+# -------+-------
+# target | host
+# host   | build
+
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+	CC=$(CC) CXX=$(CXX) PKG_CONFIG=$(PKG_CONFIG) CC_host=$(CC_FOR_BUILD) CXX_host=$(CXX_FOR_BUILD) ./configure --cross-compiling $(DEB_CONFIGURE_EXTRA_FLAGS)
+else
 	./configure $(DEB_CONFIGURE_EXTRA_FLAGS)
+endif
 
 override_dh_auto_build-arch:
 	mkdir -p $(NODE_TEST_DIR)

=== debian/tests/control ===
Test-Command: ./debian/rules check
Depends: @, ca-certificates, python3, python3-distutils, procps, curl, build-essential
